Summary:        Perl interface to process XML using the libxml2 library
Name:           perl-XML-LibXML
Version:        2.0209
Release:        4%{?dist}
License:        (GPL+ or Artistic) and MIT
URL:            https://metacpan.org/release/XML-LibXML
Source0:        https://cpan.metacpan.org/authors/id/S/SH/SHLOMIF/XML-LibXML-%{version}.tar.gz 
Patch0001:      XML-LibXML-2.0202-Parse-an-ampersand-entity-in-SAX-interface.patch
# Replace Alien::Libxml2 with pkg-config to reduce dependencies
Patch3000:      XML-LibXML-2.0208-Use-pkgconfig-instead-of-Alien-Libxml2.patch

BuildRequires:  gcc make glibc-common coreutils findutils
BuildRequires:  libxml2-devel pkgconfig(libxml-2.0)
BuildRequires:  perl-generators perl-devel perl-interpreter perl(Config)
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict) perl(warnings)
# Run-time
BuildRequires:  perl(base) perl(Carp) perl(constant)
BuildRequires:  perl(Data::Dumper) perl(Encode) perl(Exporter)
BuildRequires:  perl(IO::File) perl(IO::Handle) perl(overload) perl(parent)
BuildRequires:  perl(Scalar::Util) perl(Tie::Hash) perl(vars)
BuildRequires:  perl(XML::NamespaceSupport) perl(XML::SAX::Base)
BuildRequires:  perl(XML::SAX::DocumentLocator) perl(XML::SAX::Exception)
BuildRequires:  perl(XSLoader)
# Tests
# t/12html.t exhibits ISO-8859-2 charset
BuildRequires:  glibc-gconv-extra
BuildRequires:  perl(Errno) perl(File::Spec) perl(lib)
BuildRequires:  perl(locale) perl(POSIX)
BuildRequires:  perl(Test::More)
BuildRequires:  perl(XML::SAX) perl(XML::SAX::ParserFactory)
BuildRequires:  perl(URI::file) perl(utf8)

Requires:       perl(Data::Dumper)
Requires:       perl-interpreter
Requires(preun):perl-interpreter
Provides:       perl-XML-LibXML-Common = %{version}

%{?perl_default_filter}
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(Collector\\)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(Counter)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(Stacker)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(TestHelpers)\s*$
%global __requires_exclude %{__requires_exclude}|^perl\\(Test::LeakTrace)\s*$

%description
This module implements a Perl interface to the GNOME libxml2 library
which provides interfaces for parsing and manipulating XML files. This
module allows Perl programmers to make use of the highly capable
validating XML parser and the high performance DOM implementation.


%prep
%autosetup -n XML-LibXML-%{version} -p1
perl -i -pe 's/\r\n/\n/' t/91unique_key.t

# Recognise the Perl scripts
for file in t/*.t; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "${file}"
    chmod +x "${file}"
done


%build
perl Makefile.PL SKIP_SAX_INSTALL=1 INSTALLDIRS=vendor OPTIMIZE="%{optflags}" NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}


%install
%{make_install}
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} %{buildroot}/*


%check
export HARNESS_OPTIONS=j%{_smp_build_ncpus}
THREAD_TEST=0 make test


%triggerin -- perl-XML-SAX
for p in XML::LibXML::SAX::Parser XML::LibXML::SAX ; do
  %{_bindir}/perl -MXML::SAX -e "XML::SAX->add_parser(q($p))->save_parsers()" 2>/dev/null || :
done

%preun
if [ $1 -eq 0 ] ; then
  for p in XML::LibXML::SAX::Parser XML::LibXML::SAX ; do
    %{_bindir}/perl -MXML::SAX -e "XML::SAX->remove_parser(q($p))->save_parsers()" 2>/dev/null || :
  done
fi


%files
%license LICENSE
%doc Changes HACKING.txt README TODO
%{perl_vendorarch}/auto/XML
%{perl_vendorarch}/XML
%{_mandir}/man3/*.3*


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0209-4
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0209-3
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.0209-2
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Mon Aug 07 2023 rockerzhu <rockerzhu@tencent.com> - 2.0209-1
- Upgrade to 2.0209 to fix test with libxml2 2.11.

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0207-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0207-2
- Rebuilt for OpenCloudOS Stream 23

* Tue Aug 02 2022 rockerzhu <rockerzhu@tencent.com> - 2.0207-1
- Initail build
